--======================================================--
--                                                      --
--  NORTHEASTERN UNIVERSITY                             --
--  DEPARTMENT OF ELECTRICAL AND COMPUTER ENGINEERING   --
--  RAPID PROTOTYPING LABORATORY                        --
--                                                      --
--  FILE         | mux2.vhd                             --
--  -------------+------------------------------------  --
--  DESCRIPTION  | 1-bit multiplexer                    --
--  -------------+------------------------------------  --
--  AUTHOR       | Pavle Belanovic                      --
--  -------------+------------------------------------  --
--  DATE         | 20 June 2002                         --
--                                                      --
--======================================================--

--******************************************************************************--
--                                                                              --
--	Copyright (C) 2000 Pavle Belanovic                                          --
--                                                                              --
--	This program is free software; you can redistribute it and/or               --
--	modify it under the terms of the GNU General Public License                 --
--	as published by the Free Software Foundation; either version 2              --
--	of the License, or (at your option) any later version.                      --
--                                                                              --
--	This program is distributed in the hope that it will be useful,             --
--	but WITHOUT ANY WARRANTY; without even the implied warranty of              --
--	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               --
--	GNU General Public License for more details.                                --
--                                                                              --
--	You should have received a copy of the GNU General Public License           --
--	along with this program; if not, write to the Free Software                 --
--	Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. --
--                                                                              --
--******************************************************************************--

--======================================================--
--                      LIBRARIES                       --
--======================================================--

-- IEEE Libraries --
library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.std_logic_arith.all;
use IEEE.std_logic_unsigned.all;

-- float
library work;
use work.float_pkg.all;

----------------------------------------------------------
--                One bit multiplexer                   --
----------------------------------------------------------
entity mux2 is
	port
	(
		--inputs
		A			:	in		std_logic;
		B			:	in		std_logic;
		S			:	in		std_logic;
		--outputs
		O			:	out		std_logic		:=	'0'
	);
end mux2;

----------------------------------------------------------
--                One bit multiplexer                   --
----------------------------------------------------------
architecture mux2_arch of mux2 is
	signal	im1		:		std_logic	:=	'0';
	signal	im2		:		std_logic	:=	'0';
	signal	ns		:		std_logic	:=	'0';
begin
	ns	<=	NOT(S);
	im1	<=	A AND S;
	im2	<=	B AND ns;
	--outputs
	O		<=	im1 OR im2 AFTER 1000 ps;
end mux2_arch; -- end of architecture

